module table;

import std.string;

alias char[] string;
/*
class Record
{
    Record prev, next;
    string[] values;
}
*/
typedef string[] Record;


string[][] ParseTSV( in string tsv )
out(result) {
    // each row should have the same number of fields
    foreach(r; result)
	assert(r.length == result[0].length);
}
body {
    string[][] result;
    auto rows = std.string.split( tsv, "\n" );
    result.length = rows.length;
    result.length = 0;
    foreach(x; rows) {
//		asm{int 3;}
	auto fields = std.string.split( x, "\t" );
	if (fields.length)
	    result ~= fields;
    }
    return result;
}

struct Table
{
    uint[string]	columnid;	// column name => column id
    string[]		columns;
    Record		records[];
//    uint[][string]	indices[];	// should not be uint
    Record[]		indices[];	// should not be uint
/*
    void buildIndex(uint colno) 
    {
	uint[][string] index;	
	foreach(i,record;records)
	    index[record[colno]] ~= i;
	while (colno >= indices.length)
	    indices ~= null;
	indices[colno] = index;	
    }
    uint[] queryIndex(uint colno, string query)	    
    {
	auto index = indices[colno];
	auto precords = query in index;
	return precords?*precords:null;
    }	*/
    void buildIndex(uint colno) 
    {
	// TODO	
    }
    Record queryIndex(uint colno, string query, out Record[] pre, out Record[] post )
    {
	// binary search for query
	bool subquery( uint lo, uint hi, inout uint mid ) 
	{
	    mid = (lo+hi)>>>1;
	    auto val = records[mid][colno];
	    auto cmp = val <> query;
	    if (cmp==0)
		return true;
		if (lo==hi)
		    return false;
	    if (cmp<0) {
		mid++;	
		return subquery(mid,hi,mid);
	    }
	    else {
		return subquery(lo,mid,mid);
	    }
	}	
	uint pos;
	if (subquery( 0, records.length, pos )) {
	    pre = records[0..pos];
	    post = records[pos+1..$];
	    return records[pos];	
	}
	else {
	    pre = records[0..pos];
	    post = records[pos..$];
	    return null;	
	}
    }	
}

void FillTable( inout Table table, char[] tsv )
{
    auto rows = split( tsv, "\n" );
    // The first row has the column names
    table.columns = split( rows[0], "\t" );
    foreach(i,inout c;table.columns) {
	c = c.strip();
	table.columnid[c] = i;//no need to dup
    }
    foreach(row; rows[1..$]) {
	auto values = split( row, "\t" );
	foreach(inout v;values)
	    v = v.strip();	
	while(values.length < table.columns.length)
	    values ~= null;	
	table.records ~= cast(Record)values;
    }
    delete table.indices;
}
